
rm(list = ls()); gc()
setwd("/esarchive/scratch/nperez/git/auto-s2s/")
recipe_file <- "/esarchive/scratch/nperez/git/s2s-suite/recipes/NAO_recipe.yml"


source("modules/Loading/Loading.R")
source("modules/Calibration/Calibration.R")
source("modules/Skill/Skill.R")
source("modules/Saving/Saving.R")
source("tools/prepare_outputs.R")
source("modules/Anomalies/Anomalies.R")
recipe <- prepare_outputs(recipe_file)
source("/esarchive/scratch/nperez/git/s2dv/R/NAO.R")
library(s2dv)
#for (smonth in 1:12) {
  #smonth = 1
## Define recipe needed to load calibrated data and skill metrics
  #recipe$Analysis$Time$sdate <- paste0(sprintf("%02d", smonth), '01')
## Load datasets
  data <- load_datasets(recipe)
  gc()
  data <- compute_anomalies(recipe, data)
  ########################################
  # Required lines if region is not espified in recipe:
  hcst1 <- ClimProjDiags::SelBox(data$hcst$data, 
                                 lon = as.vector(data$hcst$lon), 
                                 lat = as.vector(data$hcst$lat), 
                                 region = c(lonmin = -80, lonmax = 40,
                                            latmin = 20, latmax = 80))
  obs1 <- ClimProjDiags::SelBox(data$obs$data, 
                                 lon = as.vector(data$obs$lon), 
                                 lat = as.vector(data$obs$lat), 
                                 region = c(lonmin = -80, lonmax = 40,
                                            latmin = 20, latmax = 80))
  hcst2 <- s2dv_cube(data = hcst1$data, lat = hcst1$lat, lon = hcst1$lon,
                     Variable = c(data$hcst$Variable[1], level = 'surface'),
                     data$hcst$Va, Datasets = data$hcst$Datasets, 
                     time_dims = c('syear', 'time'),
                     Dates = data$hcst$Dates)
  obs2 <- s2dv_cube(data = obs1$data, lat = obs1$lat, lon = obs1$lon,
                    Variable = c(data$obs$Variable[1], level = 'surface'),
                    Datasets = data$obs$Datasets, time_dims = c('syear', 'time'),
                    Dates = data$obs$Dates)
  nao2 <- s2dv::NAO(exp = hcst2$data, obs = obs2$data,
                   lat = hcst2$lat, lon = hcst2$lon,
                   time_dim = 'syear',
                   memb_dim = 'ensemble', space_dim = c('latitude', 'longitude'),
                   ftime_dim = 'time', ftime_avg = 1:2, 
                   obsproj = TRUE, ncores = 5)
  ##########################################
  .EOF <- s2dv:::.EOF
  .ProjectField <- s2dv:::.ProjectField
  nao <- NAO(exp = data$hcst$data, obs = data$obs$data,
                   lat = data$hcst$lat, lon = data$hcst$lon,
                   time_dim = 'syear',
                   memb_dim = 'ensemble', space_dim = c('latitude', 'longitude'),
                   ftime_dim = 'time', ftime_avg = 1, 
                   obsproj = FALSE, ncores = 5)
  ## Results from s2dverification are equal
  # test <- drop(data$hcst$data)
  # test <- Reorder(test, c(5,1,2,3,4))
  # test <- InsertDim(test, posdim = 1, lendim = 1, name = "nexp")
  # names(dim(test)) <- c("nexp", "nmember", "sdate", "ftime", "lat", "lon")
  # test2 <- drop(data$obs$data)
  # test2 <- InsertDim(test2, posdim = 1, lendim = 1, name = "nexp")
  # test2 <- InsertDim(test2, posdim = 2, lendim = 1, name = "nmember")
  # names(dim(test2)) <- c("nexp", "nmember", "sdate", "ftime", "lat", "lon")
  # nao2 <- s2dverification::NAO(ano_exp = test, ano_obs = test2,
  #                              lon = data$hcst$lon, lat = data$hcst$lat,
  #                              ftime_average = 1, obsproj = TRUE) 
  # str(nao2)
  # all(round(drop(nao2$NAO_obs),1) == round(drop(nao$obs), 1))
  # all(round(drop(nao2$NAO_exp),1) == round(t(drop(nao$exp)), 1))
  # 
  # str(nao)
  nao$exp <- InsertDim(nao$exp, posdim = 7, lendim = 1, name = 'latitude')
  nao$exp <- InsertDim(nao$exp, posdim = 7, lendim = 1, name = 'longitude')
  nao$obs <- InsertDim(nao$obs, posdim = 7, lendim = 1, name = 'latitude')
  nao$obs <- InsertDim(nao$obs, posdim = 7, lendim = 1, name = 'longitude')
  nao_s2dv <- list(hcst = s2dv_cube(data = nao$exp, lon = NULL, lat = NULL,
                                    Variable = c(data$hcst$Variable[1], level = 'surface'),
                                    data$hcst$Va, Datasets = data$hcst$Datasets, 
                                    time_dims = 'syear',
                                    Dates = list(start = 1993:2016)),
                   obs = s2dv_cube(data = nao$obs, lon = NULL, lat = NULL,
                                   Variable = c(data$obs$Variable[1], level = 'surface'),
                                   Datasets = data$obs$Datasets, time_dims = c('syear', 'time'),
                                   Dates = list(start = 1993:2016)))
## Compute skill metrics of raw data
  skill_metrics <- compute_skill_metrics(recipe, nao_s2dv)
  archive <- read_yaml(paste0(recipe$Run$code_dir, "conf/archive.yml"))$archive
  
 # recipe$Analysis$Workflow$Skill$metric <- "corr"
 # skill_metrics2 <- compute_skill_metrics(recipe, nao_s2dv)
  save_data(recipe, data = NULL, skill_metrics = skill_metrics)  
#}


##### Script requires module Phantomjs, currently only available in Nord3 
##### Load Phantomjs in Nord3 before running script: module load Phantomjs

##### To open R in Nord·: 
#  module load R/4.1.2-foss-2019b
#  module load OpenMPI/4.0.5-GCC-8.3.0-nord3-v2
#  R


### Temporarily to be able to run without loading data first ###
setwd("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/")
library(yaml)
recipe_file <- "recipes/recipe_1_nadia_scorecards.yml"
recipe <- read_yaml(recipe_file)
archive <- read_yaml(paste0(recipe$Run$code_dir, "conf/archive.yml"))$archive
variable_dictionary <- read_yaml(paste0(recipe$Run$code_dir, "conf/variable-dictionary.yml"))$vars
type_dictionary <- read_yaml(paste0(recipe$Run$code_dir, "conf/scorecard_type.yml"))$types

input.path <- '/esarchive/scratch/nmilders/scorecards_data/input_data'
fileout <- '/esarchive/scratch/nmilders/scorecards_data/saved_results'

currentworkingdir <- getwd()

## Load configuration file 
source("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/modules/Scorecards/SC_0_configuration_functions.R")
## functions not used but libraries to be loaded


## Load data files
source("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/modules/Scorecards/SC_1_load_metrics.R")
#loaded_metrics <- SC_load_metrics(recipe)
loaded_metrics <- SC_load_metrics(system.filename = c('ecmwfs5','dwds21'),
                                  reference.filename = 'era5',
                                  var.filename = 'tas',
                                  start.year = 1993,
                                  end.year = 2016,
                                  metrics =  c('mean_bias', 'enscorr', 'rpss', 'crpss', 'enssprerr'),
                                  start.months = sprintf("%02d", 1:12),
                                  forecast.months = 1:6,
                                  input.path = '/esarchive/scratch/nmilders/scorecards_data/input_data')



## Calculate weighted mean of spatial aggregation
source("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/modules/Scorecards/SC_2_spatial_aggregation.R")
aggregated_metrics <- SC_spatial_aggregation(loaded_metrics,
                                             metrics = c('mean_bias', 'enscorr', 'rpss', 'crpss', 'enssprerr'), 
                                             regions = list(global = c(lon.min = -90, lat.max = 90, lon.min = 0, lon.max = 360),
                                                          europe = c(lat.min = 30, lat.max = 70, lon.min = -10, lon.max = 40)),
                                             ncores = 4)

## Transform metrics 
source("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/modules/Scorecards/SC_3_transform_data.R")
transformed_data <- SC_transform_data(aggregated_metrics, 
                                      sdate_dim = 'sdate',
                                      ftime_dim = 'time')

## Create scorecard
source("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/modules/Scorecards/SC_3_create_scorecard.R")
scorecard_table <- SC_create_table(transformed_data)

## Save scorecard
source("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/modules/Scorecards/SC_4_save_scorecard.R")
save_scorecard <- SC_save_image(system.filename, reference.filename, var.name, var.filename, period, scorecard_type)

setwd(currentworkingdir)


#################### PARAMETERS FROM RECIPE ########################

# start.year <- recipe$Analysis$Time$hcst_start ## 1993
# end.year <- recipe$Analysis$Time$hcst_end ## 2016
# 
# system.filename <- archive$System[[recipe$Analysis$Datasets$System$name]]$system_filename ## 'ecmwfs5'
# system.name <- archive$System[[recipe$Analysis$Datasets$System$name]]$system_name ## 'ECMWF System 5
# 
# reference.name <- archive$Reference[[recipe$Analysis$Datasets$Reference$name]]$reference_name ## 'ERA5'
# reference.filename <- archive$Reference[[recipe$Analysis$Datasets$Reference$name]]$reference_filename ## 'era5'
# 
# var.filename <- recipe$Analysis$Variables$name ## 'tas'
# var.name <- variable-dictionary$vars[[recipe$Analysis$Variables$name]]$long_name ##
# var.unit <- variable-dictionary$vars[[recipe$Analysis$Variables$name]]$units ## 'K'

#plevel <- '' # because single levels

